﻿using System;
using Npgsql;
using Helios.Models;

namespace Helios.Source
{
	public class LoginService
	{
		private readonly NpgsqlConnection _connection;

        private string password = string.Empty;

        public LoginService(string connectionString)
        {
            _connection = new NpgsqlConnection(connectionString);
        }

        public Login GetLogin(string email, string password)
        {
            this.password = password;

            Login userLogin = new Login();

            userLogin.EmailAddress = email;
            userLogin = GetUserDetails(userLogin);

            return userLogin;
        }

        private Login GetUserDetails(Login userLogin)
        {
            _connection.Open();

            NpgsqlCommand cmd = new NpgsqlCommand("select * from user_login where email = @emailParam and user_password = @passwordParam", _connection);

            cmd.Parameters.AddWithValue("@emailParam", userLogin.EmailAddress);
            cmd.Parameters.AddWithValue("@passwordParam", this.password);

            using var reader = cmd.ExecuteReader();

            if (reader.Read())
            {
                userLogin.IsValidUser = true;
                userLogin.IsAdmin = bool.Parse(reader["is_admin"].ToString());
            }
            else
            {
                userLogin.IsValidUser = false;
                userLogin.IsAdmin = false;
            }

            _connection.Close();

            return userLogin;
        }
    }
}

